unit mainWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImageViewer, ExtCtrls, StdCtrls, Menus, ActnList, ComCtrls, DLASim,
  Themes, RejbrandCommon, ShellAPI, Clipbrd;

const MaxSize = 1048576;

type
  TmainFrm = class(TForm)
    ImageViewer: TImageViewer;
    ActionList: TActionList;
    aNew: TAction;
    MainMenu: TMainMenu;
    Fractal1: TMenuItem;
    New1: TMenuItem;
    aExit: TAction;
    Exit1: TMenuItem;
    N1: TMenuItem;
    aDrawPointInCentre: TAction;
    aDrawCircle: TAction;
    aDrawLineInMiddle: TAction;
    aDrawLineAtBottom: TAction;
    aDrawBoundary: TAction;
    Draw1: TMenuItem;
    Pointincentre1: TMenuItem;
    Linebottom1: TMenuItem;
    Linemiddle1: TMenuItem;
    Boundary1: TMenuItem;
    Circle1: TMenuItem;
    aSimulate: TAction;
    Simulate1: TMenuItem;
    aSimulate1: TMenuItem;
    aStop: TAction;
    Pause1: TMenuItem;
    aSave: TAction;
    Save1: TMenuItem;
    aSetSize: TAction;
    Fractal2: TMenuItem;
    Setsize1: TMenuItem;
    StatusBar1: TStatusBar;
    N2: TMenuItem;
    aClear: TAction;
    Clear1: TMenuItem;
    aSettings: TAction;
    Settings1: TMenuItem;
    N3: TMenuItem;
    aLoadBitmap: TAction;
    Open1: TMenuItem;
    AutoUpdater: TTimer;
    aAutoPreview: TAction;
    Autopreview1: TMenuItem;
    N4: TMenuItem;
    aPreviewNow: TAction;
    Previewnow1: TMenuItem;
    Help1: TMenuItem;
    aAbout: TAction;
    About1: TMenuItem;
    aModeCircularTrue: TAction;
    aModeUniform: TAction;
    aModeBoundary: TAction;
    aModeTop: TAction;
    N5: TMenuItem;
    Mode1: TMenuItem;
    Circular1: TMenuItem;
    Uniform1: TMenuItem;
    Boundary2: TMenuItem;
    op1: TMenuItem;
    aCircularCompensator: TAction;
    CircularCompensator1: TMenuItem;
    aCopy: TAction;
    Copy1: TMenuItem;
    N6: TMenuItem;
    Compute1: TMenuItem;
    aDrawRandomPoints: TAction;
    Randompoints1: TMenuItem;
    aModeCircularFast: TAction;
    Circularfast1: TMenuItem;
    aStatistics: TAction;
    Statistics1: TMenuItem;
    procedure btnSaveBMClick(Sender: TObject);
    procedure aExitExecute(Sender: TObject);
    procedure aNewExecute(Sender: TObject);
    procedure aSetSizeExecute(Sender: TObject);
    procedure aClearExecute(Sender: TObject);
    procedure aDrawPointInCentreExecute(Sender: TObject);
    procedure aDrawCircleExecute(Sender: TObject);
    procedure aDrawLineInMiddleExecute(Sender: TObject);
    procedure aDrawLineAtBottomExecute(Sender: TObject);
    procedure aDrawBoundaryExecute(Sender: TObject);
    procedure aSimulateExecute(Sender: TObject);
    procedure aStopExecute(Sender: TObject);
    procedure UpdateImage;
    procedure aSimulateUpdate(Sender: TObject);
    procedure aStopUpdate(Sender: TObject);
    procedure aSaveExecute(Sender: TObject);
    procedure NotWhileRunning(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure aSettingsExecute(Sender: TObject);
    procedure aLoadBitmapExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AutoUpdaterTimer(Sender: TObject);
    procedure aAutoPreviewExecute(Sender: TObject);
    procedure aPreviewNowExecute(Sender: TObject);
    procedure aAboutExecute(Sender: TObject);
    procedure aModeCircularTrueExecute(Sender: TObject);
    procedure aModeUniformExecute(Sender: TObject);
    procedure aModeBoundaryExecute(Sender: TObject);
    procedure aModeCircularTrueUpdate(Sender: TObject);
    procedure aModeUniformUpdate(Sender: TObject);
    procedure aModeBoundaryUpdate(Sender: TObject);
    procedure aCircularCompensatorUpdate(Sender: TObject);
    procedure aCircularCompensatorExecute(Sender: TObject);
    procedure aCopyExecute(Sender: TObject);
    procedure aDrawRandomPointsExecute(Sender: TObject);
    procedure aModeCircularFastExecute(Sender: TObject);
    procedure aModeCircularFastUpdate(Sender: TObject);
    procedure aStatisticsExecute(Sender: TObject);
  private
    procedure SetStatus(const Status: string); overload;
    procedure SetStatus; overload;
    procedure TaskDialogHyperLinkClicked(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
    DLAFractal: TDLAFractal;
  end;

var
  mainFrm: TmainFrm;

implementation

uses SuperDialog, settingsWin;

{$R *.dfm}

procedure TmainFrm.TaskDialogHyperLinkClicked(Sender: TObject);
begin
  if Sender is TTaskDialog then
    with Sender as TTaskDialog do
      ShellExecute(Handle, 'open', PChar(URL), nil, nil, SW_SHOWNORMAL);
end;

procedure TmainFrm.aAboutExecute(Sender: TObject);
begin
  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(self) do
      try
        Caption := 'About DLA Simulator';
        Title := 'DLA Simulator';
        CommonButtons := [tcbClose];
        Text := 'File Version: ' + GetFileVer(Application.ExeName) + #13#10#13#10'Copyright  2012 Andreas Rejbrand'#13#10#13#10'<a href="http://english.rejbrand.se">http://english.rejbrand.se</a>';
        Flags := [tfUseHiconMain, tfEnableHyperlinks];
        CustomMainIcon := Application.Icon;
        OnHyperlinkClicked := TaskDialogHyperlinkClicked;
        Execute;
      finally
        Free;
      end
  else
    // Windows XP Compatibility Code
    MessageBox(Handle, PChar('File Version: ' + GetFileVer(Application.ExeName) + #13#10#13#10 + 'Copyright  2012 Andreas Rejbrand' + #13#10#13#10 + 'http://english.rejbrand.se' + #13#10#13#10 + 'DLA Simulator is running in Windows XP Compatibility Mode.'), PChar('DLA Simulator'), MB_ICONINFORMATION);
end;

procedure TmainFrm.aAutoPreviewExecute(Sender: TObject);
begin
  {SIC!};
end;

procedure TmainFrm.aCircularCompensatorExecute(Sender: TObject);
begin
  DLAFractal.CircularCompensator := not DLAFractal.CircularCompensator;
end;

procedure TmainFrm.aCircularCompensatorUpdate(Sender: TObject);
begin
  aCircularCompensator.Checked := DLAFractal.CircularCompensator or (DLAFractal.Mode = dlaCircularTrue);
  aCircularCompensator.Enabled := (DLAFractal.Mode <> dlaCircularTrue) and not DLAFractal.Running;
end;

procedure TmainFrm.aClearExecute(Sender: TObject);
begin
  DLAFractal.FillWhite;
  UpdateImage;
end;

procedure TmainFrm.aCopyExecute(Sender: TObject);
begin
  Clipboard.Assign(ImageViewer.Bitmap);
end;

procedure TmainFrm.aDrawBoundaryExecute(Sender: TObject);
begin
  DLAFractal.DrawBoundary;
  UpdateImage;
end;

procedure TmainFrm.aDrawCircleExecute(Sender: TObject);
var
  r: integer;
begin
  r := 100;
  if TMultiInputBox.NumInputBox(Self, 'Draw Circle',
    'Please enter the radius of the circle:', 0, MaxSize, r) then
  begin
    DLAFractal.DrawCircle(r);
    UpdateImage;
  end;
end;

procedure TmainFrm.aDrawLineAtBottomExecute(Sender: TObject);
begin
  DLAFractal.DrawLineAtBottom;
  UpdateImage;
end;

procedure TmainFrm.aDrawLineInMiddleExecute(Sender: TObject);
begin
  DLAFractal.DrawLineAtMiddle;
  UpdateImage;
end;

procedure TmainFrm.aDrawPointInCentreExecute(Sender: TObject);
begin
  DLAFractal.DrawPointAtCentre;
  UpdateImage;
end;

procedure TmainFrm.aDrawRandomPointsExecute(Sender: TObject);
var
  n: integer;
begin
  n := 5;
  if TMultiInputBox.NumInputBox(Self, 'Draw Points',
    'Please enter the number of points to draw:', 0, MaxSize, n) then
  begin
    DLAFractal.DrawRandomPoints(n);
    UpdateImage;
  end;
end;

procedure TmainFrm.aExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TmainFrm.aLoadBitmapExecute(Sender: TObject);
begin
  with TOpenDialog.Create(nil) do
    try
      Filter := '32-bit Windows Bitmap|*.bmp';
      if Execute then
      begin
        DLAFractal.LoadFromFile(FileName);
        UpdateImage;
      end;
    finally
      Free;
    end;
end;

procedure TmainFrm.aModeBoundaryExecute(Sender: TObject);
begin
  DLAFractal.Mode := dlaBoundary;
end;

procedure TmainFrm.aModeBoundaryUpdate(Sender: TObject);
begin
  aModeBoundary.Checked := DLAFractal.Mode = dlaBoundary;
  aModeBoundary.Enabled := not DLAFractal.Running;
end;

procedure TmainFrm.aModeCircularFastExecute(Sender: TObject);
begin
  DLAFractal.Mode := dlaCircularFast;
end;

procedure TmainFrm.aModeCircularFastUpdate(Sender: TObject);
begin
  aModeCircularFast.Checked := DLAFractal.Mode = dlaCircularFast;
  aModeCircularFast.Enabled := not DLAFractal.Running;
end;

procedure TmainFrm.aModeCircularTrueExecute(Sender: TObject);
begin
  DLAFractal.Mode := dlaCircularTrue;
  DLAFractal.CircularCompensator := false;
end;

procedure TmainFrm.aModeCircularTrueUpdate(Sender: TObject);
begin
  aModeCircularTrue.Checked := DLAFractal.Mode = dlaCircularTrue;
  aModeCircularTrue.Enabled := not DLAFractal.Running;
end;

procedure TmainFrm.aModeUniformExecute(Sender: TObject);
begin
  DLAFractal.Mode := dlaUniform;
end;

procedure TmainFrm.aModeUniformUpdate(Sender: TObject);
begin
  aModeUniform.Checked := DLAFractal.Mode = dlaUniform;
  aModeUniform.Enabled := not DLAFractal.Running;
end;

procedure TmainFrm.aNewExecute(Sender: TObject);
begin
  DLAFractal.Free;
  DLAFractal := TDLAFractal.Create;
  DLAFractal.SetSize(512, 512);
  DLAFractal.FillWhite;
  UpdateImage;
end;

procedure TmainFrm.aPreviewNowExecute(Sender: TObject);
begin
  UpdateImage;
end;

procedure TmainFrm.aSaveExecute(Sender: TObject);
begin
  with TSaveDialog.Create(nil) do
    try
      Filter := '32-bit Windows Bitmap|*.bmp';
      if Execute then
        DLAFractal.SaveToFile(FileName);
    finally
      Free;
    end;
end;

procedure TmainFrm.aSetSizeExecute(Sender: TObject);
var
  w, h: integer;
begin
  w := DLAFractal.Width;
  h := DLAFractal.Height;
  if TMultiInputBox.NumInputBox(Self, 'Image Size',
    'Please enter the width of the image:', 6, MaxSize, w) then
    if TMultiInputBox.NumInputBox(Self, 'Image Size',
      'Please enter the height of the image:', 6, MaxSize, h) then
    begin
      DLAFractal.SetSize(w, h);
      DLAFractal.FillWhite;
      UpdateImage;
    end;
end;

procedure TmainFrm.aSettingsExecute(Sender: TObject);
begin
  with TsettingsFrm.Create(nil) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TmainFrm.aSimulateExecute(Sender: TObject);
begin
  DLAFractal.Simulate;
  SetStatus('Simulating');
  AutoUpdater.Enabled := true;
end;

procedure TmainFrm.aSimulateUpdate(Sender: TObject);
begin
  aSimulate.Enabled := not DLAFractal.Running;
end;

procedure TmainFrm.aStatisticsExecute(Sender: TObject);
begin
  with DLAFractal do
    MessageBox(Handle,
      PChar(Format('Width: %d'#13#10'Height: %d'#13#10'Radius: %f'#13#10 +
        'Number of particles: %d', [Width, Height, Radius, ParticleCount])),
      PChar('Statistics'), MB_ICONINFORMATION);
end;

procedure TmainFrm.aStopExecute(Sender: TObject);
begin
  AutoUpdater.Enabled := false;
  DLAFractal.Pause;
  UpdateImage;
  SetStatus;
end;

procedure TmainFrm.aStopUpdate(Sender: TObject);
begin
  aStop.Enabled := DLAFractal.Running;
end;

procedure TmainFrm.AutoUpdaterTimer(Sender: TObject);
begin
  if aAutoPreview.Checked then UpdateImage;
end;

procedure TmainFrm.btnSaveBMClick(Sender: TObject);
begin
  with TSaveDialog.Create(nil) do
    try
      Filter := '32-bit Windows Bitmap|*.bmp';
      if Execute then
        ImageViewer.Bitmap.SaveToFile(FileName);
    finally
      Free;
    end;
end;

procedure TmainFrm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := true;
  if DLAFractal.Running then
  begin
    CanClose := MessageBox(Handle, 'Do you want to terminate the ongoing simulation and close the application?',
      'Simulation in progress', MB_ICONQUESTION or MB_YESNO) = ID_YES;
    if CanClose then DLAFractal.Pause;
  end;
end;

procedure TmainFrm.FormCreate(Sender: TObject);
begin
  DLAFractal := TDLAFractal.Create;
  DLAFractal.SetSize(512, 512);
  DLAFractal.FillWhite;
  DLAFractal.DrawPointAtCentre;
  UpdateImage;
end;

procedure TmainFrm.NotWhileRunning(Sender: TObject);
begin
  if Sender is TAction then
    with Sender as TAction do
      Enabled := not DLAFractal.Running;
end;

procedure TmainFrm.SetStatus;
begin
  Caption := 'DLA Simulator';
end;

procedure TmainFrm.UpdateImage;
begin
  ImageViewer.Bitmap.Free;
  ImageViewer.Bitmap := DLAFractal.CreateGDIBitmap;
end;

procedure TmainFrm.SetStatus(const Status: string);
begin
  Caption := Format('DLA Simulator [%s]', [Status]);
end;

end.
